/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//				 
//				http://www.interestprograms.ru
//				    ,  
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// MyEdit.cpp : implementation file
#include "stdafx.h"
#include "MyEdit.h"
#include ".\myedit.h"


// CMyEdit

IMPLEMENT_DYNAMIC(CMyEdit, CEdit)
CMyEdit::CMyEdit()
{
	m_Brush.CreateSolidBrush(RGB(255,255,255));
	m_ColorText = RGB(0,0,0);
	m_Font.CreatePointFont(80, "Microsoft Sans Serif");
}

CMyEdit::~CMyEdit()
{
	//   
	if(m_Brush.m_hObject != NULL)
		m_Brush.DeleteObject();
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
}


BEGIN_MESSAGE_MAP(CMyEdit, CEdit)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_CREATE()
	ON_CONTROL_REFLECT(EN_CHANGE, OnEnChange)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CMyEdit message handlers

/*
    " "        MFC -
   Window-.

         ,
   MFC  4.0.
CMyEdit       (WM_CTLCOLOR) 
  (   CTestMyEditDlg),
           
  .      
 HBRUSH CtlColor(CDC* pDC, UINT nCtlColor),    
       .  ClassWizard
    HBRUSH CtlColor(CDC* pDC, UINT nCtlColor)  
     ON_WM_CTLCOLOR_REFLECT().    .
*/

HBRUSH CMyEdit::CtlColor(CDC* pDC, UINT nCtlColor)
{
	//    
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(m_ColorText);


	// TODO:  Return a non-NULL brush if the parent's handler should not be called
	//            
	//     (return NULL)      
	//   
	return m_Brush;
}


BOOL CMyEdit::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CEdit::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	//cs.style &= ~WS_BORDER;
}

int CMyEdit::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CEdit::OnCreate(lpCreateStruct) == -1)
		return -1;

	//   
	SetFont(&m_Font);

	return 0;
}

/*
    CMyEdit   , 
         2 
*/

//   CMyEdit
BOOL CMyEdit::CreateMyEdit(const CRect& rect, CWnd* parent, const unsigned int& ID)
{
	BOOL result = Create(WS_VISIBLE|ES_AUTOHSCROLL, rect, parent, ID);
	SetMargins(2,2);
	return result;
}


//   
void CMyEdit::SetColorBG(const COLORREF& color)
{
	//       
	if(m_Brush.m_hObject != NULL)
		m_Brush.DeleteObject();

	//     
	m_Brush.CreateSolidBrush(color);
	Invalidate();
}
//    
COLORREF CMyEdit::GetColorBG(void) const
{
	return m_ColorBG;
}

/*
           
*/
//   
void CMyEdit::SetColorText(const COLORREF& color)
{
	m_ColorText = color;
	Invalidate();
}
//   
COLORREF CMyEdit::GetColorText(void) const
{
	return m_ColorText;
}

/*
       - , ,  
*/

//   
void CMyEdit::SetMyEditFont(const int& height, const int& weight, const CString& fontname)
{
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT)); // 
	lf.lfHeight = height;  
	lf.lfWeight = weight;
	lf.lfCharSet = RUSSIAN_CHARSET;
	strcpy(lf.lfFaceName, fontname);
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
	VERIFY(m_Font.CreateFontIndirect(&lf)); 
	SetFont(&m_Font);
}
/*
         
*/
//   
void CMyEdit::SetMyEditFont(LOGFONT* logfont)
{
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
	VERIFY(m_Font.CreateFontIndirect(logfont)); 
	SetFont(&m_Font);
}

//   CFont
CFont* CMyEdit::GetMyEditFont(void)
{
	return &m_Font;
}
/*
        
        
*/

//      CMyEdit
void CMyEdit::OnEnChange()
{
	GetParent()->SendMessage( WM_MYEDIT_CHANGE, (WPARAM)m_hWnd);
}

